/**
	Programa que realiza el movimiento
	del  caballo  en  un  tablero
	Fraga 8/01/1999
**/

# include <stdio.h>
# include <stdlib.h>

int intento( int x, int y, int *to_x, int *to_y);

int l;
/*************************************/
/*  Aqui se inicializan los areglos  */
/*************************************/
int a[8] = { 2, 1,-1,-2,-2,-1, 1, 2}; /** Horizontal **/
int b[8] = {-1,-2,-2,-1, 1, 2, 2, 1}; /** Vertical   **/

int h[8][8];

// int accessboard[8][8] = { 
// 	{2,3,4,4,4,4,3,2},
// 	{3,4,6,6,6,6,4,3},
// 	{4,6,8,8,8,8,6,4},
// 	{4,6,8,8,8,8,6,4},
// 	{4,6,8,8,8,8,6,4},
// 	{4,6,8,8,8,8,6,4},
// 	{3,4,6,6,6,6,4,3},
// 	{2,3,4,4,4,4,3,2},
// };

int accessboard[8][8] = { 
	{2, 3, 4, 4, 4, 4, 3,2},
	{3, 8,12,12,12,12, 8,3},
	{4,12,16,16,16,16,12,4},
	{4,12,16,16,16,16,12,4},
	{4,12,16,16,16,16,12,4},
	{4,12,16,16,16,16,12,4},
	{3, 8,12,12,12,12, 8,3},
	{2, 3, 4, 4, 4, 4, 3,2},
};

int access2[8][8] = { 
	{1,1,1,1,1,1,1,1},
	{1,2,2,2,2,2,2,1},
	{1,2,2,2,2,2,2,1},
	{1,2,2,2,2,2,2,1},
	{1,2,2,2,2,2,2,1},
	{1,2,2,2,2,2,2,1},
	{1,2,2,2,2,2,2,1},
	{1,1,1,1,1,1,1,1},
};
int accessibility[8];

/************************************/
/*  Con esto evitamos que se ocupe  */
/*  memoria  en  nuestro  programa  */
/************************************/
#define FALSO  0
#define CIERTO 1

/************************************/
/*  Este es el cuerpo del programa  */
/************************************/
main ( int argc, char *argv[] )
{

 /***********************************/
 /*  Acontinuacion  definimos  las  */
 /***********************************/
 int exito, r, c; 	
 int tirada=0;
 int adonder, adondec;

 /************************************/
 /* Esta parte nos permite dar direc */
 /* tamente el tamano del tablero, - */
 /* la columna y fila de inicio  sin */
 /* tener que pasar a  la  serie  de */
 /* preguntas!!.		     */
 /************************************/
 if  ( argc < 2 ) {
    fprintf( stderr, "Args: i/[n] {tamao fila columna] \n");
    exit(1);
 }
 if ( argv[1][0] == 'n' ) {
    if ( argc < 5 ) {
       fprintf( stderr, "Args: i/n tamao fila columna\n");
       exit(1);
    }
   l = atoi( argv[2] );
   r = atoi( argv[3] );
   c = atoi( argv[4] );
 }
 else if ( argv[1][0] == 'i' ) {
    system("clear");
    printf("\n\n");
    printf(" \t\tTIRADAS DEL CABALLO EN AJEDREZ \n\n");
    printf("\tDa el tamao del tablero:\t");
    scanf("%d",&l);
    printf("\n");
    printf("\tEscribe la fila de inicio:\t");
    scanf("%d",&r);
    printf("\tEscribe la columna de inicio:\t");
    scanf("%d",&c);
    printf("\n");
 }
 else {
     fprintf( stderr, "Args: i/n tamao fila columna\n");
     exit(1);
 }
  

 h[r][c] = 1;

 /** printf("Para tener exito deben ser %d tiradas\n", l*l );**/
 do {
 /**   printf("%d, (%d,%d)\n", tirada+1, r, c); **/
    exito=intento(r,c, &adonder, &adondec);
    tirada ++;
    r = adonder;
    c = adondec;
 } while( exito==CIERTO && tirada<64 );

 if ( tirada < 64 ){ 
    printf("NO HAY SOLUCION %d\n", tirada);      
	exit(1);
 }
 else{
    printf("Ok!\n");      
	exit(0);
 }
}

 /**************************************/
 /* Esta parte es la que realiiza  los */
 /* movimientos del caballo en nuestro */
 /* programa que se explicara al final */
 /* del mismo!!!!		       */
 /**************************************/
int intento( int y, int x, int *to_y, int *to_x)
{
	int i, j, k=0, u, v;
	int solutions[8], aux[8];

	/** Vemos a donde tirar, contruyendo primero
       la "accesibilidad" **/
	for ( i=0; i<8; i++ ) {
		u=x+a[i]; /** Movimiento horizontal **/  
		v=y+b[i]; /** Movimiento vertical   **/
		if(0<=u && u<l && 0<=v && v<l && h[v][u]==0){
			accessibility[i] = accessboard[v][u];
		}
		else {
			accessibility[i] = 30;
		}
	}

	/** Buscamos la menor "accesabilidad" **/
	k=100;
	for ( i=0; i<8; i++ ) {
		if ( accessibility[i] < k ) {
			k = accessibility[i];
			j = i; 
		}
	}
	
	if ( accessibility[j] < 30 ) {
		u=x+a[j]; /** Movimiento horizontal **/  
		v=y+b[j]; /** Movimiento vertical   **/

		h[v][u]=1;

		*to_y = v;
		*to_x = u;

		for ( i=0; i<8; i++ ) {
			u=x+a[i]; /** Movimiento horizontal **/  
			v=y+b[i]; /** Movimiento vertical   **/

			if(0<=u && u<l && 0<=v && v<l ){
				accessboard[v][u] -= 1;
			}
		}
		return( CIERTO );
	}
	else return( FALSO );

}    


/****************************************************************/
/*								*/
/*  Este programa sigue la combinacion de un par de ecuaciones  */
/*  que son: (u=x+a[k]) la cual realiza el movimiento del ca--  */
/*  ballo en forma horizontal y v=y+b[k] que realiza el movi--  */
/*  miento  en  forma  vertical,  se  siguen los ocho posibles  */
/*  del caballo, siempre uno seguido del otro. 			*/
/****************************************************************/
